/* game.c generated by valac 0.47.3, the Vala compiler
 * generated from game.vala, do not modify */

/*
 * Copyright (C) 2010-2013 Robert Ancell
 *
 * This program is free software: you can redistribute it and/or modify it under
 * the terms of the GNU General Public License as published by the Free Software
 * Foundation, either version 2 of the License, or (at your option) any later
 * version. See http://www.gnu.org/copyleft/gpl.html the full text of the
 * license.
 */

#include <glib-object.h>
#include <glib.h>
#include <math.h>

#define TYPE_TILE (tile_get_type ())
#define TILE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TILE, Tile))
#define TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TILE, TileClass))
#define IS_TILE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TILE))
#define IS_TILE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TILE))
#define TILE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TILE, TileClass))

typedef struct _Tile Tile;
typedef struct _TileClass TileClass;
typedef struct _TilePrivate TilePrivate;
enum  {
	TILE_0_PROPERTY,
	TILE_CLOSED_PROPERTY,
	TILE_NUM_PROPERTIES
};
static GParamSpec* tile_properties[TILE_NUM_PROPERTIES];
enum  {
	TILE_MOVE_SIGNAL,
	TILE_CLOSE_SIGNAL,
	TILE_NUM_SIGNALS
};
static guint tile_signals[TILE_NUM_SIGNALS] = {0};

#define TYPE_GAME (game_get_type ())
#define GAME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GAME, Game))
#define GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GAME, GameClass))
#define IS_GAME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GAME))
#define IS_GAME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GAME))
#define GAME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GAME, GameClass))

typedef struct _Game Game;
typedef struct _GameClass GameClass;
typedef struct _GamePrivate GamePrivate;
enum  {
	GAME_0_PROPERTY,
	GAME_SCORE_PROPERTY,
	GAME_COLOR_NUM_PROPERTY,
	GAME_ROWS_PROPERTY,
	GAME_COLUMNS_PROPERTY,
	GAME_NUM_PROPERTIES
};
static GParamSpec* game_properties[GAME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	GAME_UPDATE_SCORE_SIGNAL,
	GAME_COMPLETE_SIGNAL,
	GAME_STARTED_SIGNAL,
	GAME_NUM_SIGNALS
};
static guint game_signals[GAME_NUM_SIGNALS] = {0};

struct _Tile {
	GObject parent_instance;
	TilePrivate * priv;
	gint grid_x;
	gint grid_y;
	gint color;
	gboolean visited;
};

struct _TileClass {
	GObjectClass parent_class;
};

struct _TilePrivate {
	gboolean _closed;
};

struct _Game {
	GObject parent_instance;
	GamePrivate * priv;
};

struct _GameClass {
	GObjectClass parent_class;
};

struct _GamePrivate {
	Tile** tiles;
	gint tiles_length1;
	gint tiles_length2;
	gboolean is_started;
	gint _score;
	gint _color_num;
	gint _rows;
	gint _columns;
};

static gint Tile_private_offset;
static gpointer tile_parent_class = NULL;
static gint Game_private_offset;
static gpointer game_parent_class = NULL;

GType tile_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Tile, g_object_unref)
Tile* tile_new (gint x,
                gint y,
                gint c);
Tile* tile_construct (GType object_type,
                      gint x,
                      gint y,
                      gint c);
void tile_update_position (Tile* self,
                           gint new_x,
                           gint new_y);
gboolean tile_get_closed (Tile* self);
void tile_set_closed (Tile* self,
                      gboolean value);
static void g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                            GValue * return_value,
                                            guint n_param_values,
                                            const GValue * param_values,
                                            gpointer invocation_hint,
                                            gpointer marshal_data);
static void tile_finalize (GObject * obj);
static GType tile_get_type_once (void);
static void _vala_tile_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_tile_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
GType game_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Game, g_object_unref)
Game* game_new (gint rows,
                gint columns,
                gint color_num);
Game* game_construct (GType object_type,
                      gint rows,
                      gint columns,
                      gint color_num);
static GList* _game_connected_tiles (Game* self,
                              Tile* li);
gint game_get_rows (Game* self);
gint game_get_columns (Game* self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
GList* game_connected_tiles (Game* self,
                             Tile* li);
Tile* game_get_tile (Game* self,
                     gint x,
                     gint y);
gboolean game_remove_connected_tiles (Game* self,
                                      Tile* tile);
void game_increment_score_from_tiles (Game* self,
                                      gint n_tiles);
gboolean game_has_completed (Game* self);
gboolean game_has_won (Game* self);
void game_increment_score (Game* self,
                           gint increment);
void game_reset_visit (Game* self);
gint game_get_score (Game* self);
void game_set_score (Game* self,
                     gint value);
gint game_get_color_num (Game* self);
void game_set_color_num (Game* self,
                         gint value);
void game_set_rows (Game* self,
                    gint value);
void game_set_columns (Game* self,
                       gint value);
static void game_finalize (GObject * obj);
static GType game_get_type_once (void);
static void _vala_game_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec);
static void _vala_game_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
tile_get_instance_private (Tile* self)
{
	return G_STRUCT_MEMBER_P (self, Tile_private_offset);
}

Tile*
tile_construct (GType object_type,
                gint x,
                gint y,
                gint c)
{
	Tile * self = NULL;
	self = (Tile*) g_object_new (object_type, NULL);
	self->grid_x = x;
	self->grid_y = y;
	self->color = c;
	return self;
}

Tile*
tile_new (gint x,
          gint y,
          gint c)
{
	return tile_construct (TYPE_TILE, x, y, c);
}

void
tile_update_position (Tile* self,
                      gint new_x,
                      gint new_y)
{
	gint old_x = 0;
	gint old_y = 0;
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	old_x = self->grid_x;
	old_y = self->grid_y;
	if (new_x != old_x) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = new_y != old_y;
	}
	if (_tmp0_) {
		gboolean _tmp1_;
		gboolean _tmp2_;
		self->grid_x = new_x;
		self->grid_y = new_y;
		_tmp1_ = tile_get_closed (self);
		_tmp2_ = _tmp1_;
		if (!_tmp2_) {
			g_signal_emit (self, tile_signals[TILE_MOVE_SIGNAL], 0, old_x, old_y, new_x, new_y);
		}
	}
}

gboolean
tile_get_closed (Tile* self)
{
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	result = self->priv->_closed;
	return result;
}

void
tile_set_closed (Tile* self,
                 gboolean value)
{
	g_return_if_fail (self != NULL);
	self->priv->_closed = value;
	if (self->priv->_closed) {
		g_signal_emit (self, tile_signals[TILE_CLOSE_SIGNAL], 0, self->grid_x, self->grid_y);
	}
	g_object_notify_by_pspec ((GObject *) self, tile_properties[TILE_CLOSED_PROPERTY]);
}

static void
g_cclosure_user_marshal_VOID__INT_INT_INT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT_INT_INT) (gpointer data1, gint arg_1, gint arg_2, gint arg_3, gint arg_4, gpointer data2);
	register GMarshalFunc_VOID__INT_INT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 5);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT_INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), g_value_get_int (param_values + 4), data2);
}

static void
g_cclosure_user_marshal_VOID__INT_INT (GClosure * closure,
                                       GValue * return_value,
                                       guint n_param_values,
                                       const GValue * param_values,
                                       gpointer invocation_hint,
                                       gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__INT_INT) (gpointer data1, gint arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 3);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__INT_INT) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_int (param_values + 1), g_value_get_int (param_values + 2), data2);
}

static void
tile_class_init (TileClass * klass,
                 gpointer klass_data)
{
	tile_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Tile_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_tile_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_tile_set_property;
	G_OBJECT_CLASS (klass)->finalize = tile_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), TILE_CLOSED_PROPERTY, tile_properties[TILE_CLOSED_PROPERTY] = g_param_spec_boolean ("closed", "closed", "closed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	tile_signals[TILE_MOVE_SIGNAL] = g_signal_new ("move", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT_INT_INT, G_TYPE_NONE, 4, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT, G_TYPE_INT);
	tile_signals[TILE_CLOSE_SIGNAL] = g_signal_new ("close", TYPE_TILE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__INT_INT, G_TYPE_NONE, 2, G_TYPE_INT, G_TYPE_INT);
}

static void
tile_instance_init (Tile * self,
                    gpointer klass)
{
	self->priv = tile_get_instance_private (self);
	self->priv->_closed = FALSE;
	self->visited = FALSE;
}

static void
tile_finalize (GObject * obj)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TILE, Tile);
	G_OBJECT_CLASS (tile_parent_class)->finalize (obj);
}

/**
 *  This is the model layer of a tile.
 */
static GType
tile_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (TileClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tile_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tile), 0, (GInstanceInitFunc) tile_instance_init, NULL };
	GType tile_type_id;
	tile_type_id = g_type_register_static (G_TYPE_OBJECT, "Tile", &g_define_type_info, 0);
	Tile_private_offset = g_type_add_instance_private (tile_type_id, sizeof (TilePrivate));
	return tile_type_id;
}

GType
tile_get_type (void)
{
	static volatile gsize tile_type_id__volatile = 0;
	if (g_once_init_enter (&tile_type_id__volatile)) {
		GType tile_type_id;
		tile_type_id = tile_get_type_once ();
		g_once_init_leave (&tile_type_id__volatile, tile_type_id);
	}
	return tile_type_id__volatile;
}

static void
_vala_tile_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
	switch (property_id) {
		case TILE_CLOSED_PROPERTY:
		g_value_set_boolean (value, tile_get_closed (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_tile_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Tile * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TILE, Tile);
	switch (property_id) {
		case TILE_CLOSED_PROPERTY:
		tile_set_closed (self, g_value_get_boolean (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static inline gpointer
game_get_instance_private (Game* self)
{
	return G_STRUCT_MEMBER_P (self, Game_private_offset);
}

Game*
game_construct (GType object_type,
                gint rows,
                gint columns,
                gint color_num)
{
	Game * self = NULL;
	Tile** _tmp0_;
	self = (Game*) g_object_new (object_type, NULL);
	self->priv->_rows = rows;
	self->priv->_columns = columns;
	self->priv->_color_num = color_num;
	_tmp0_ = g_new0 (Tile*, (rows * columns) + 1);
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
	self->priv->tiles = _tmp0_;
	self->priv->tiles_length1 = rows;
	self->priv->tiles_length2 = columns;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = x;
					x = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				if (!(x < columns)) {
					break;
				}
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp3_ = FALSE;
						_tmp3_ = TRUE;
						while (TRUE) {
							gint c = 0;
							Tile** _tmp5_;
							gint _tmp5__length1;
							gint _tmp5__length2;
							Tile* _tmp6_;
							if (!_tmp3_) {
								gint _tmp4_;
								_tmp4_ = y;
								y = _tmp4_ + 1;
							}
							_tmp3_ = FALSE;
							if (!(y < rows)) {
								break;
							}
							c = (gint) floor (g_random_double () * color_num);
							_tmp5_ = self->priv->tiles;
							_tmp5__length1 = self->priv->tiles_length1;
							_tmp5__length2 = self->priv->tiles_length2;
							_tmp6_ = tile_new (x, y, c);
							_g_object_unref0 (_tmp5_[(y * _tmp5__length2) + x]);
							_tmp5_[(y * _tmp5__length2) + x] = _tmp6_;
						}
					}
				}
			}
		}
	}
	self->priv->is_started = FALSE;
	return self;
}

Game*
game_new (gint rows,
          gint columns,
          gint color_num)
{
	return game_construct (TYPE_GAME, rows, columns, color_num);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
_g_object_unref0_ (gpointer var)
{
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
}

static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
}

static GList*
_game_connected_tiles (Game* self,
                       Tile* li)
{
	GList* cl = NULL;
	gboolean _tmp0_ = FALSE;
	gint x = 0;
	gint y = 0;
	Tile* _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gint _tmp6_;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	gboolean _tmp23_ = FALSE;
	gboolean _tmp24_ = FALSE;
	gint _tmp25_;
	gboolean _tmp33_ = FALSE;
	gboolean _tmp34_ = FALSE;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	cl = NULL;
	if (li->visited) {
		_tmp0_ = TRUE;
	} else {
		gboolean _tmp1_;
		gboolean _tmp2_;
		_tmp1_ = tile_get_closed (li);
		_tmp2_ = _tmp1_;
		_tmp0_ = _tmp2_;
	}
	if (_tmp0_) {
		result = cl;
		return result;
	}
	x = li->grid_x;
	y = li->grid_y;
	li->visited = TRUE;
	_tmp3_ = _g_object_ref0 (li);
	cl = g_list_append (cl, _tmp3_);
	_tmp6_ = self->priv->_rows;
	if ((y + 1) < _tmp6_) {
		Tile** _tmp7_;
		gint _tmp7__length1;
		gint _tmp7__length2;
		Tile* _tmp8_;
		_tmp7_ = self->priv->tiles;
		_tmp7__length1 = self->priv->tiles_length1;
		_tmp7__length2 = self->priv->tiles_length2;
		_tmp8_ = _tmp7_[((y + 1) * _tmp7__length2) + x];
		_tmp5_ = _tmp8_ != NULL;
	} else {
		_tmp5_ = FALSE;
	}
	if (_tmp5_) {
		Tile** _tmp9_;
		gint _tmp9__length1;
		gint _tmp9__length2;
		Tile* _tmp10_;
		_tmp9_ = self->priv->tiles;
		_tmp9__length1 = self->priv->tiles_length1;
		_tmp9__length2 = self->priv->tiles_length2;
		_tmp10_ = _tmp9_[((y + 1) * _tmp9__length2) + x];
		_tmp4_ = li->color == _tmp10_->color;
	} else {
		_tmp4_ = FALSE;
	}
	if (_tmp4_) {
		Tile** _tmp11_;
		gint _tmp11__length1;
		gint _tmp11__length2;
		Tile* _tmp12_;
		GList* _tmp13_;
		_tmp11_ = self->priv->tiles;
		_tmp11__length1 = self->priv->tiles_length1;
		_tmp11__length2 = self->priv->tiles_length2;
		_tmp12_ = _tmp11_[((y + 1) * _tmp11__length2) + x];
		_tmp13_ = _game_connected_tiles (self, _tmp12_);
		cl = g_list_concat (cl, _tmp13_);
	}
	if ((y - 1) >= 0) {
		Tile** _tmp16_;
		gint _tmp16__length1;
		gint _tmp16__length2;
		Tile* _tmp17_;
		_tmp16_ = self->priv->tiles;
		_tmp16__length1 = self->priv->tiles_length1;
		_tmp16__length2 = self->priv->tiles_length2;
		_tmp17_ = _tmp16_[((y - 1) * _tmp16__length2) + x];
		_tmp15_ = _tmp17_ != NULL;
	} else {
		_tmp15_ = FALSE;
	}
	if (_tmp15_) {
		Tile** _tmp18_;
		gint _tmp18__length1;
		gint _tmp18__length2;
		Tile* _tmp19_;
		_tmp18_ = self->priv->tiles;
		_tmp18__length1 = self->priv->tiles_length1;
		_tmp18__length2 = self->priv->tiles_length2;
		_tmp19_ = _tmp18_[((y - 1) * _tmp18__length2) + x];
		_tmp14_ = li->color == _tmp19_->color;
	} else {
		_tmp14_ = FALSE;
	}
	if (_tmp14_) {
		Tile** _tmp20_;
		gint _tmp20__length1;
		gint _tmp20__length2;
		Tile* _tmp21_;
		GList* _tmp22_;
		_tmp20_ = self->priv->tiles;
		_tmp20__length1 = self->priv->tiles_length1;
		_tmp20__length2 = self->priv->tiles_length2;
		_tmp21_ = _tmp20_[((y - 1) * _tmp20__length2) + x];
		_tmp22_ = _game_connected_tiles (self, _tmp21_);
		cl = g_list_concat (cl, _tmp22_);
	}
	_tmp25_ = self->priv->_columns;
	if ((x + 1) < _tmp25_) {
		Tile** _tmp26_;
		gint _tmp26__length1;
		gint _tmp26__length2;
		Tile* _tmp27_;
		_tmp26_ = self->priv->tiles;
		_tmp26__length1 = self->priv->tiles_length1;
		_tmp26__length2 = self->priv->tiles_length2;
		_tmp27_ = _tmp26_[(y * _tmp26__length2) + (x + 1)];
		_tmp24_ = _tmp27_ != NULL;
	} else {
		_tmp24_ = FALSE;
	}
	if (_tmp24_) {
		Tile** _tmp28_;
		gint _tmp28__length1;
		gint _tmp28__length2;
		Tile* _tmp29_;
		_tmp28_ = self->priv->tiles;
		_tmp28__length1 = self->priv->tiles_length1;
		_tmp28__length2 = self->priv->tiles_length2;
		_tmp29_ = _tmp28_[(y * _tmp28__length2) + (x + 1)];
		_tmp23_ = li->color == _tmp29_->color;
	} else {
		_tmp23_ = FALSE;
	}
	if (_tmp23_) {
		Tile** _tmp30_;
		gint _tmp30__length1;
		gint _tmp30__length2;
		Tile* _tmp31_;
		GList* _tmp32_;
		_tmp30_ = self->priv->tiles;
		_tmp30__length1 = self->priv->tiles_length1;
		_tmp30__length2 = self->priv->tiles_length2;
		_tmp31_ = _tmp30_[(y * _tmp30__length2) + (x + 1)];
		_tmp32_ = _game_connected_tiles (self, _tmp31_);
		cl = g_list_concat (cl, _tmp32_);
	}
	if ((x - 1) >= 0) {
		Tile** _tmp35_;
		gint _tmp35__length1;
		gint _tmp35__length2;
		Tile* _tmp36_;
		_tmp35_ = self->priv->tiles;
		_tmp35__length1 = self->priv->tiles_length1;
		_tmp35__length2 = self->priv->tiles_length2;
		_tmp36_ = _tmp35_[(y * _tmp35__length2) + (x - 1)];
		_tmp34_ = _tmp36_ != NULL;
	} else {
		_tmp34_ = FALSE;
	}
	if (_tmp34_) {
		Tile** _tmp37_;
		gint _tmp37__length1;
		gint _tmp37__length2;
		Tile* _tmp38_;
		_tmp37_ = self->priv->tiles;
		_tmp37__length1 = self->priv->tiles_length1;
		_tmp37__length2 = self->priv->tiles_length2;
		_tmp38_ = _tmp37_[(y * _tmp37__length2) + (x - 1)];
		_tmp33_ = li->color == _tmp38_->color;
	} else {
		_tmp33_ = FALSE;
	}
	if (_tmp33_) {
		Tile** _tmp39_;
		gint _tmp39__length1;
		gint _tmp39__length2;
		Tile* _tmp40_;
		GList* _tmp41_;
		_tmp39_ = self->priv->tiles;
		_tmp39__length1 = self->priv->tiles_length1;
		_tmp39__length2 = self->priv->tiles_length2;
		_tmp40_ = _tmp39_[(y * _tmp39__length2) + (x - 1)];
		_tmp41_ = _game_connected_tiles (self, _tmp40_);
		cl = g_list_concat (cl, _tmp41_);
	}
	result = cl;
	return result;
}

GList*
game_connected_tiles (Game* self,
                      Tile* li)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	GList* cl = NULL;
	GList* _tmp4_;
	GList* _tmp5_;
	GList* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (li != NULL, NULL);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				Tile* _tmp2_;
				_tmp2_ = l;
				if (_tmp2_ != NULL) {
					Tile* _tmp3_;
					_tmp3_ = l;
					_tmp3_->visited = FALSE;
				}
				_g_object_unref0 (l);
			}
		}
	}
	_tmp4_ = _game_connected_tiles (self, li);
	cl = _tmp4_;
	_tmp5_ = cl;
	if (g_list_length (_tmp5_) < ((guint) 2)) {
		(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
		cl = NULL;
	}
	result = cl;
	return result;
}

Tile*
game_get_tile (Game* self,
               gint x,
               gint y)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	Tile* _tmp1_;
	Tile* _tmp2_;
	Tile* result = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	_tmp1_ = _tmp0_[(y * _tmp0__length2) + x];
	_tmp2_ = _g_object_ref0 (_tmp1_);
	result = _tmp2_;
	return result;
}

gboolean
game_remove_connected_tiles (Game* self,
                             Tile* tile)
{
	GList* cl = NULL;
	GList* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
	gint new_x = 0;
	GList* _tmp49_;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (tile != NULL, FALSE);
	_tmp0_ = game_connected_tiles (self, tile);
	cl = _tmp0_;
	_tmp1_ = cl;
	if (_tmp1_ == NULL) {
		result = FALSE;
		(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
		return result;
	}
	_tmp2_ = cl;
	{
		GList* l_collection = NULL;
		GList* l_it = NULL;
		l_collection = _tmp2_;
		for (l_it = l_collection; l_it != NULL; l_it = l_it->next) {
			Tile* _tmp3_;
			Tile* l = NULL;
			_tmp3_ = _g_object_ref0 ((Tile*) l_it->data);
			l = _tmp3_;
			{
				Tile* _tmp4_;
				_tmp4_ = l;
				tile_set_closed (_tmp4_, TRUE);
				_g_object_unref0 (l);
			}
		}
	}
	new_x = 0;
	{
		gint x = 0;
		x = 0;
		{
			gboolean _tmp5_ = FALSE;
			_tmp5_ = TRUE;
			while (TRUE) {
				gint _tmp7_;
				GList* not_closed_tiles = NULL;
				GList* closed_tiles = NULL;
				GList* _tmp22_;
				gboolean has_empty_col = FALSE;
				if (!_tmp5_) {
					gint _tmp6_;
					_tmp6_ = x;
					x = _tmp6_ + 1;
				}
				_tmp5_ = FALSE;
				_tmp7_ = self->priv->_columns;
				if (!(x < _tmp7_)) {
					break;
				}
				not_closed_tiles = NULL;
				closed_tiles = NULL;
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp8_ = FALSE;
						_tmp8_ = TRUE;
						while (TRUE) {
							gint _tmp10_;
							Tile* li = NULL;
							Tile** _tmp11_;
							gint _tmp11__length1;
							gint _tmp11__length2;
							Tile* _tmp12_;
							Tile* _tmp13_;
							Tile* _tmp14_;
							Tile* _tmp15_;
							gboolean _tmp16_;
							gboolean _tmp17_;
							if (!_tmp8_) {
								gint _tmp9_;
								_tmp9_ = y;
								y = _tmp9_ + 1;
							}
							_tmp8_ = FALSE;
							_tmp10_ = self->priv->_rows;
							if (!(y < _tmp10_)) {
								break;
							}
							_tmp11_ = self->priv->tiles;
							_tmp11__length1 = self->priv->tiles_length1;
							_tmp11__length2 = self->priv->tiles_length2;
							_tmp12_ = _tmp11_[(y * _tmp11__length2) + x];
							_tmp13_ = _g_object_ref0 (_tmp12_);
							li = _tmp13_;
							_tmp14_ = li;
							if (_tmp14_ == NULL) {
								_g_object_unref0 (li);
								break;
							}
							_tmp15_ = li;
							_tmp16_ = tile_get_closed (_tmp15_);
							_tmp17_ = _tmp16_;
							if (_tmp17_) {
								Tile* _tmp18_;
								Tile* _tmp19_;
								_tmp18_ = li;
								_tmp19_ = _g_object_ref0 (_tmp18_);
								closed_tiles = g_list_append (closed_tiles, _tmp19_);
							} else {
								Tile* _tmp20_;
								Tile* _tmp21_;
								_tmp20_ = li;
								_tmp21_ = _g_object_ref0 (_tmp20_);
								not_closed_tiles = g_list_append (not_closed_tiles, _tmp21_);
							}
							_g_object_unref0 (li);
						}
					}
				}
				_tmp22_ = closed_tiles;
				closed_tiles = NULL;
				not_closed_tiles = g_list_concat (not_closed_tiles, _tmp22_);
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp23_ = FALSE;
						_tmp23_ = TRUE;
						while (TRUE) {
							gint _tmp25_;
							Tile** _tmp26_;
							gint _tmp26__length1;
							gint _tmp26__length2;
							GList* _tmp27_;
							gconstpointer _tmp28_;
							Tile* _tmp29_;
							if (!_tmp23_) {
								gint _tmp24_;
								_tmp24_ = y;
								y = _tmp24_ + 1;
							}
							_tmp23_ = FALSE;
							_tmp25_ = self->priv->_rows;
							if (!(y < _tmp25_)) {
								break;
							}
							_tmp26_ = self->priv->tiles;
							_tmp26__length1 = self->priv->tiles_length1;
							_tmp26__length2 = self->priv->tiles_length2;
							_tmp27_ = not_closed_tiles;
							_tmp28_ = g_list_nth_data (_tmp27_, (guint) y);
							_tmp29_ = _g_object_ref0 ((Tile*) _tmp28_);
							_g_object_unref0 (_tmp26_[(y * _tmp26__length2) + new_x]);
							_tmp26_[(y * _tmp26__length2) + new_x] = _tmp29_;
						}
					}
				}
				has_empty_col = TRUE;
				{
					gint y = 0;
					y = 0;
					{
						gboolean _tmp30_ = FALSE;
						_tmp30_ = TRUE;
						while (TRUE) {
							gint _tmp32_;
							Tile* l = NULL;
							Tile** _tmp33_;
							gint _tmp33__length1;
							gint _tmp33__length2;
							Tile* _tmp34_;
							Tile* _tmp35_;
							Tile* _tmp36_;
							Tile* _tmp37_;
							Tile* _tmp38_;
							gboolean _tmp39_;
							gboolean _tmp40_;
							if (!_tmp30_) {
								gint _tmp31_;
								_tmp31_ = y;
								y = _tmp31_ + 1;
							}
							_tmp30_ = FALSE;
							_tmp32_ = self->priv->_rows;
							if (!(y < _tmp32_)) {
								break;
							}
							_tmp33_ = self->priv->tiles;
							_tmp33__length1 = self->priv->tiles_length1;
							_tmp33__length2 = self->priv->tiles_length2;
							_tmp34_ = _tmp33_[(y * _tmp33__length2) + new_x];
							_tmp35_ = _g_object_ref0 (_tmp34_);
							l = _tmp35_;
							_tmp36_ = l;
							if (_tmp36_ == NULL) {
								_g_object_unref0 (l);
								break;
							}
							_tmp37_ = l;
							tile_update_position (_tmp37_, new_x, y);
							_tmp38_ = l;
							_tmp39_ = tile_get_closed (_tmp38_);
							_tmp40_ = _tmp39_;
							if (!_tmp40_) {
								has_empty_col = FALSE;
							}
							_g_object_unref0 (l);
						}
					}
				}
				if (!has_empty_col) {
					gint _tmp41_;
					_tmp41_ = new_x;
					new_x = _tmp41_ + 1;
				}
				(closed_tiles == NULL) ? NULL : (closed_tiles = (_g_list_free__g_object_unref0_ (closed_tiles), NULL));
				(not_closed_tiles == NULL) ? NULL : (not_closed_tiles = (_g_list_free__g_object_unref0_ (not_closed_tiles), NULL));
			}
		}
	}
	{
		gboolean _tmp42_ = FALSE;
		_tmp42_ = TRUE;
		while (TRUE) {
			gint _tmp44_;
			if (!_tmp42_) {
				gint _tmp43_;
				_tmp43_ = new_x;
				new_x = _tmp43_ + 1;
			}
			_tmp42_ = FALSE;
			_tmp44_ = self->priv->_columns;
			if (!(new_x < _tmp44_)) {
				break;
			}
			{
				gint y = 0;
				y = 0;
				{
					gboolean _tmp45_ = FALSE;
					_tmp45_ = TRUE;
					while (TRUE) {
						gint _tmp47_;
						Tile** _tmp48_;
						gint _tmp48__length1;
						gint _tmp48__length2;
						if (!_tmp45_) {
							gint _tmp46_;
							_tmp46_ = y;
							y = _tmp46_ + 1;
						}
						_tmp45_ = FALSE;
						_tmp47_ = self->priv->_rows;
						if (!(y < _tmp47_)) {
							break;
						}
						_tmp48_ = self->priv->tiles;
						_tmp48__length1 = self->priv->tiles_length1;
						_tmp48__length2 = self->priv->tiles_length2;
						_g_object_unref0 (_tmp48_[(y * _tmp48__length2) + new_x]);
						_tmp48_[(y * _tmp48__length2) + new_x] = NULL;
					}
				}
			}
		}
	}
	_tmp49_ = cl;
	game_increment_score_from_tiles (self, (gint) g_list_length (_tmp49_));
	if (!self->priv->is_started) {
		self->priv->is_started = TRUE;
		g_signal_emit (self, game_signals[GAME_STARTED_SIGNAL], 0);
	}
	if (game_has_completed (self)) {
		if (game_has_won (self)) {
			game_increment_score (self, 1000);
		}
		g_signal_emit (self, game_signals[GAME_COMPLETE_SIGNAL], 0);
	}
	result = FALSE;
	(cl == NULL) ? NULL : (cl = (_g_list_free__g_object_unref0_ (cl), NULL));
	return result;
}

void
game_reset_visit (Game* self)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				Tile* _tmp2_;
				_tmp2_ = l;
				if (_tmp2_ != NULL) {
					Tile* _tmp3_;
					_tmp3_ = l;
					_tmp3_->visited = FALSE;
				}
				_g_object_unref0 (l);
			}
		}
	}
}

gboolean
game_has_completed (Game* self)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				gboolean _tmp2_ = FALSE;
				gboolean _tmp3_ = FALSE;
				Tile* _tmp4_;
				_tmp4_ = l;
				if (_tmp4_ != NULL) {
					Tile* _tmp5_;
					gboolean _tmp6_;
					gboolean _tmp7_;
					_tmp5_ = l;
					_tmp6_ = tile_get_closed (_tmp5_);
					_tmp7_ = _tmp6_;
					_tmp3_ = !_tmp7_;
				} else {
					_tmp3_ = FALSE;
				}
				if (_tmp3_) {
					Tile* _tmp8_;
					GList* _tmp9_;
					GList* _tmp10_;
					_tmp8_ = l;
					_tmp9_ = game_connected_tiles (self, _tmp8_);
					_tmp10_ = _tmp9_;
					_tmp2_ = g_list_length (_tmp10_) > ((guint) 1);
					(_tmp10_ == NULL) ? NULL : (_tmp10_ = (_g_list_free__g_object_unref0_ (_tmp10_), NULL));
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					result = FALSE;
					_g_object_unref0 (l);
					return result;
				}
				_g_object_unref0 (l);
			}
		}
	}
	result = TRUE;
	return result;
}

gboolean
game_has_won (Game* self)
{
	Tile** _tmp0_;
	gint _tmp0__length1;
	gint _tmp0__length2;
	gboolean result = FALSE;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->tiles;
	_tmp0__length1 = self->priv->tiles_length1;
	_tmp0__length2 = self->priv->tiles_length2;
	{
		Tile** l_collection = NULL;
		gint l_collection_length1 = 0;
		gint l_collection_length2 = 0;
		gint l_it = 0;
		l_collection = _tmp0_;
		l_collection_length1 = _tmp0__length1 * _tmp0__length2;
		for (l_it = 0; l_it < l_collection_length1; l_it = l_it + 1) {
			Tile* _tmp1_;
			Tile* l = NULL;
			_tmp1_ = _g_object_ref0 (l_collection[l_it]);
			l = _tmp1_;
			{
				gboolean _tmp2_ = FALSE;
				Tile* _tmp3_;
				_tmp3_ = l;
				if (_tmp3_ != NULL) {
					Tile* _tmp4_;
					gboolean _tmp5_;
					gboolean _tmp6_;
					_tmp4_ = l;
					_tmp5_ = tile_get_closed (_tmp4_);
					_tmp6_ = _tmp5_;
					_tmp2_ = !_tmp6_;
				} else {
					_tmp2_ = FALSE;
				}
				if (_tmp2_) {
					result = FALSE;
					_g_object_unref0 (l);
					return result;
				}
				_g_object_unref0 (l);
			}
		}
	}
	result = TRUE;
	return result;
}

void
game_increment_score_from_tiles (Game* self,
                                 gint n_tiles)
{
	gint points_awarded = 0;
	g_return_if_fail (self != NULL);
	points_awarded = 0;
	if (n_tiles >= 3) {
		points_awarded = (n_tiles - 2) * (n_tiles - 2);
	}
	game_increment_score (self, points_awarded);
}

void
game_increment_score (Game* self,
                      gint increment)
{
	gint _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->_score;
	game_set_score (self, _tmp0_ + increment);
	g_signal_emit (self, game_signals[GAME_UPDATE_SCORE_SIGNAL], 0, increment);
}

gint
game_get_score (Game* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_score;
	return result;
}

void
game_set_score (Game* self,
                gint value)
{
	g_return_if_fail (self != NULL);
	if (game_get_score (self) != value) {
		self->priv->_score = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_SCORE_PROPERTY]);
	}
}

gint
game_get_color_num (Game* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_color_num;
	return result;
}

void
game_set_color_num (Game* self,
                    gint value)
{
	gboolean _tmp0_ = FALSE;
	g_return_if_fail (self != NULL);
	if (value < 2) {
		_tmp0_ = TRUE;
	} else {
		_tmp0_ = value > 4;
	}
	if (_tmp0_) {
		self->priv->_color_num = 3;
	} else {
		self->priv->_color_num = value;
	}
	g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLOR_NUM_PROPERTY]);
}

gint
game_get_rows (Game* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_rows;
	return result;
}

void
game_set_rows (Game* self,
               gint value)
{
	g_return_if_fail (self != NULL);
	if (game_get_rows (self) != value) {
		self->priv->_rows = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_ROWS_PROPERTY]);
	}
}

gint
game_get_columns (Game* self)
{
	gint result;
	g_return_val_if_fail (self != NULL, 0);
	result = self->priv->_columns;
	return result;
}

void
game_set_columns (Game* self,
                  gint value)
{
	g_return_if_fail (self != NULL);
	if (game_get_columns (self) != value) {
		self->priv->_columns = value;
		g_object_notify_by_pspec ((GObject *) self, game_properties[GAME_COLUMNS_PROPERTY]);
	}
}

static void
game_class_init (GameClass * klass,
                 gpointer klass_data)
{
	game_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Game_private_offset);
	G_OBJECT_CLASS (klass)->get_property = _vala_game_get_property;
	G_OBJECT_CLASS (klass)->set_property = _vala_game_set_property;
	G_OBJECT_CLASS (klass)->finalize = game_finalize;
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_SCORE_PROPERTY, game_properties[GAME_SCORE_PROPERTY] = g_param_spec_int ("score", "score", "score", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLOR_NUM_PROPERTY, game_properties[GAME_COLOR_NUM_PROPERTY] = g_param_spec_int ("color-num", "color-num", "color-num", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_ROWS_PROPERTY, game_properties[GAME_ROWS_PROPERTY] = g_param_spec_int ("rows", "rows", "rows", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	g_object_class_install_property (G_OBJECT_CLASS (klass), GAME_COLUMNS_PROPERTY, game_properties[GAME_COLUMNS_PROPERTY] = g_param_spec_int ("columns", "columns", "columns", G_MININT, G_MAXINT, 8, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
	game_signals[GAME_UPDATE_SCORE_SIGNAL] = g_signal_new ("update-score", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__INT, G_TYPE_NONE, 1, G_TYPE_INT);
	game_signals[GAME_COMPLETE_SIGNAL] = g_signal_new ("complete", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	game_signals[GAME_STARTED_SIGNAL] = g_signal_new ("started", TYPE_GAME, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}

static void
game_instance_init (Game * self,
                    gpointer klass)
{
	self->priv = game_get_instance_private (self);
	self->priv->is_started = FALSE;
	self->priv->_score = 0;
	self->priv->_color_num = 3;
	self->priv->_rows = 8;
	self->priv->_columns = 8;
}

static void
game_finalize (GObject * obj)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_GAME, Game);
	self->priv->tiles = (_vala_array_free (self->priv->tiles, self->priv->tiles_length1 * self->priv->tiles_length2, (GDestroyNotify) g_object_unref), NULL);
	G_OBJECT_CLASS (game_parent_class)->finalize (obj);
}

/**
 *  This is the model layer of the whole game. All game logic goes here. This class tries not to
 *  bring in any visual stuff to comply the separation of view-model idea.
 */
static GType
game_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (GameClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) game_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Game), 0, (GInstanceInitFunc) game_instance_init, NULL };
	GType game_type_id;
	game_type_id = g_type_register_static (G_TYPE_OBJECT, "Game", &g_define_type_info, 0);
	Game_private_offset = g_type_add_instance_private (game_type_id, sizeof (GamePrivate));
	return game_type_id;
}

GType
game_get_type (void)
{
	static volatile gsize game_type_id__volatile = 0;
	if (g_once_init_enter (&game_type_id__volatile)) {
		GType game_type_id;
		game_type_id = game_get_type_once ();
		g_once_init_leave (&game_type_id__volatile, game_type_id);
	}
	return game_type_id__volatile;
}

static void
_vala_game_get_property (GObject * object,
                         guint property_id,
                         GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SCORE_PROPERTY:
		g_value_set_int (value, game_get_score (self));
		break;
		case GAME_COLOR_NUM_PROPERTY:
		g_value_set_int (value, game_get_color_num (self));
		break;
		case GAME_ROWS_PROPERTY:
		g_value_set_int (value, game_get_rows (self));
		break;
		case GAME_COLUMNS_PROPERTY:
		g_value_set_int (value, game_get_columns (self));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_game_set_property (GObject * object,
                         guint property_id,
                         const GValue * value,
                         GParamSpec * pspec)
{
	Game * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_GAME, Game);
	switch (property_id) {
		case GAME_SCORE_PROPERTY:
		game_set_score (self, g_value_get_int (value));
		break;
		case GAME_COLOR_NUM_PROPERTY:
		game_set_color_num (self, g_value_get_int (value));
		break;
		case GAME_ROWS_PROPERTY:
		game_set_rows (self, g_value_get_int (value));
		break;
		case GAME_COLUMNS_PROPERTY:
		game_set_columns (self, g_value_get_int (value));
		break;
		default:
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
		break;
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

